'The MultiForms project illustrates how to use two forms and communicate between them.

'The forms and their controls are created entirely in code.
'However, the techniques used can be applied to forms 
'created with the Windows Form designer in the IDE.
'(A simplified overview of how to create a Windows application
'  entirely in code is given below.)

'Three methods of communicating between the forms are illustrated:
' 1) A string or other type of variable may be declared as Friend 
'     within a module, as myMessage here.
'
' 2) An object of a class may be declared as Friend, and its properties 
'     accessed within the project.
'     By way of example, in this project, myMessenger is instantiated as an object
'     of the Messenger class.
'
' 3) A form and a control within a form (class) can be declared as Friend 
'     so that it can be seen outside the containing class.
'     When this project runs, it starts at the Shared Sub Main() within the FirstForm code,
'     and an object of the FirstForm type is created, and in doing so "frm1" is given
'     that FirstForm object as its reference.
'     Within the FirstForm class, a textbox named f1TextBox is declared as Friend, 
'     so that it can be accessed outside its containing class.
'     This allows an object of the SecondForm type to change the value of the f1TextBox
'     in the FirstForm object.
'
'The MultiForms project uses one module (used to declare references to objects that
'will have project-wide scope), a class called Randomizer (for the generation of random numbers),
'a Messenger class (to create an object which is used to hold a text message), and a 
'class for each of the two forms, FirstForm and SecondForm.
'-------------------------------------------------------------------------------------------------------------------------
'To create a Windows Application in code,
'open the solution explorer (Control + R),
'right-click on the name of the solution,
'select Add > Add New Project,
'and in the Add New Project dialog box, select the Empty Project template.
'Then right-click on the name of the project,
'select Add > Add New Item,
'and choose the Code File template.
'Open as many blank code files as appropriate.

'The project must include certain references to run correctly.
'Open the Solution Explorer 
'right-click on the name of the project (not of the solution),
'select Add Reference,
'and under the .NET tab, select each of the three following:
'    System.dll
'    System.drawing.dll
'    System.Windows.Forms.dll
'
'If you have other projects in the solution,
'remember to use the Solution Explorer to 
'   "Set as Startup Project" whichever project you want to run.
