Imports System
Imports System.Drawing
Imports System.Windows.Forms

Class SecondForm
  Inherits Form

  'Note that if you close the first form,
  'you close any instance of the SecondForm class.
  'But if you close an instance of the SecondForm class,
  'the instance of the FirstForm class is *not* closed.

  'It doesn't matter that we have a myButton and a myLabel
  'declared in FirstForm because they are declared with the Dim keyword.
  'These objects (myButton and myLabel)are seen only within the 
  'class that calls them into existence.
  '(Variables declared with Dim are available to all code within 
  ' the region containing the Dim statement. - MS Help)
  Dim myButton As Button
  Dim myLabel As Label

  'Constructor for the second form:
  Public Sub New()
    Text = "Second Form"

    'myMessage is a String which has been declared as Friend
    'so its scope is project-wide.
    'Declaring a variable like this in a module
    'is one way of passing information between forms.
    MessageBox.Show(myMessage)
    'Note, however, that myMessage will only be shown when
    'a new object of the SecondForm type is created
    '(because this code is in the SecondForm constructor).

    BackColor = Color.White

    myButton = New Button
    myButton.Parent = Me
    myButton.Top = CInt(ClientSize.Height * 0.2)
    myButton.Height = CInt(ClientSize.Height * 0.2)
    myButton.Left = CInt(ClientSize.Width * 0.1)
    'Declare a font to be used for this button
    Dim myFont As Font = New Font("Arial", 10, FontStyle.Regular)
    myButton.Font = myFont
    myButton.Text = "Change form1 textbox, and give the focus to form1. "
    'The width 10 is way too small.  It's been set at this simply
    'to illustrate that the real work of sizing the button is not done here,
    'but in the code below.
    myButton.Width = 10
    AddHandler myButton.Click, AddressOf myButtonClick

    Dim g As Graphics = CreateGraphics()
    ' Get the Size needed to accommodate the formatted Text.
    Dim preferredSize As Size = g.MeasureString(myButton.Text, myFont, CInt(ClientSize.Width * 0.8)).ToSize()
    ' Pad the text and resize the control.
    myButton.Size = New Size(preferredSize.Width + 15, preferredSize.Height + 12)
    ' Clean up the Graphics object.
    g.Dispose()

    MessageBox.Show("The following message is seen only when a new instance of this form is created:" & _
          ControlChars.CrLf & ControlChars.CrLf & "Thus saith the textbox of the first form:" & _
          ControlChars.CrLf & ControlChars.CrLf & frm1.f1TextBox.Text, _
          "MessageBox shown in SecondForm")

    myLabel = New Label
    myLabel.Parent = Me
    myLabel.Top = myButton.Top + myButton.Height + 10
    myLabel.Left = myButton.Left
    myLabel.Width = CInt(ClientSize.Width * 0.8)
    myLabel.Height = CInt(ClientSize.Height * 0.3)
    myLabel.Font = New Font("Arial", 10, FontStyle.Regular)
    myLabel.Text = myMessenger.Message

  End Sub

  Protected Overrides Sub OnPaint(ByVal pea As PaintEventArgs)
    Dim grfx As Graphics = pea.Graphics
    grfx.DrawString("This text drawn using the OnPaint routine.", Font, Brushes.BlueViolet, 0, 0)
  End Sub

  Private Sub myButtonClick(ByVal sender As Object, ByVal ea As EventArgs)
    If frm1.f1TextBox.Text = "This text has been changed from form 2." Then
            frm1.f1TextBox.Text = "Every Swans premiership is a treasure-galleon sailing across the sea of history."
    Else
      frm1.f1TextBox.Text = "This text has been changed from form 2."
    End If
    myMessenger.Message = "I'm the messenger with a message from form 2."
    frm1.Focus()
  End Sub

  Private Sub SecondForm_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated
    'Using an object of a class such as Messenger declared as friend so that it can be seen
    'throughout the project is another way of passing information between forms.
    myLabel.Text = myMessenger.Message

    Dim oldnumber, newnumber As Integer
    oldnumber = CInt(Val(Microsoft.VisualBasic.Right(myMessenger.Message, 2)))
    newnumber = myRandom.DoRandom
    Do While newnumber = oldnumber
      newnumber = myRandom.DoRandom
    Loop
    myMessenger.Message = "Every time SecondForm is activated, the messenger's number changes: " & newnumber
  End Sub
End Class


